$regfile = "m32DEF.DAT"
$crystal = 8000000
Config Lcd = 16 * 4
Config Lcdpin = Pin , Db4 = Portc.1 , Db5 = Portc.3 , Db6 = Portc.0 , Db7 = Portc.2 , E = Portc.4 , Rs = Portc.5
Cls
Config Adc = Single , Prescaler = Auto
Start Adc


'-------------------------------------------------------------------------------
Config Pind.2 = Input
Config Pind.3 = Input
Config Pind.4 = Output
Config Pind.5 = Output
config pind.7 = output


Config Porta = Input
Porta = &B11110000
'-------------------------------------------------------------------------------
Config Timer0 = Timer , Prescale = 1024
On Timer0 Zegar
Enable Timer0
Timer0 = 6                                                  '8ms    dla   Prescale = 256
Start Timer0
'-------------------------------------------------------------------------------
Config Timer2 = Pwm , Prescale = 8 , Pwm = On , Compare Pwm = Clear Up
'-------------------------------------------------------------------------------
'Przerwanie dla enkodera
Config Int0 = FALLING
On Int0 Licz
Enable Int0
Enable Interrupts
'-------------------------------------------------------------------------------
dim n as word
dim t as word
dim v_a as word
dim x as word
dim v_obr as word
'-------------------------------------------------------------------------------
   Dim Auto_mode As Bit                                     ' Regulator on ?
   Dim Manual_value As Single                               ' Output if not regulating

   Dim Sp As Single                                         ' Setpoint
   Dim Pv As Single                                         ' Process Value
   Dim Cv As Single                                         ' PID output

   Dim First_execution As Byte                              ' First start recognition
   Dim Initial_error As Single                              ' Startup difference

   Dim A As Byte                                            ' Tmp for random
   Dim B As Single                                          ' Tmp for random


'   Const Kp = 4.0                                           ' Proportional factor
'   Const Ki = .3                                            ' Integration factor
'   Const Kd = .15                                           ' Derivation factor


dim kp as single
dim ki as single
dim kd as single


   Dim Last_pv As Single                                    ' Last PV
   Dim Last_sp As Single                                    ' Last SP
   Dim Sum_error As Single                                  ' Summed error value
   Dim D_pv As Single                                       ' Derrivated delta PV

   Dim Error As Single                                      ' Difference between SP and PV
   Dim Pterm As Single                                      ' Proportional calculated part
   Dim Iterm As Single                                      ' Integrated calculated part
   Dim Dterm As Single                                      ' Derivated calculated part


'*******************************************************************************
'*****  Pocztek programu
'*******************************************************************************
Cls
Lcd "test obrotw"                                          '
set portd.5
ocr2 = 10
waitms 20

 Auto_mode = 1                                              ' Permanent running choosen
 First_execution = 0                                        ' Set permanent running algorithm
 Manual_value = 40                                          ' Output if not regulating = on
 Sp = 100                                                   ' Value to aim to


'****************************************
'jako tako    dobrze
'kp 1,400     0,100
'ki 0,350     0,110
'kd 0,200     0,190
'**************************************************************

Do
 v_obr = getadc(1)
 kp = V_obr / 500
 v_obr = getadc(2)
 ki = V_obr / 500
 v_obr = getadc(3)
 kd = V_obr / 500

 If Pina.4 = 0 Then sp = sp + 100
  If Pina.6 = 0 Then sp = sp - 100


  waitms 250
  Cls
  lcd "N= " ; fusing(pv , "#.#") ; " sp =" ; sp
  lowerline
  lcd "ocr2= " ; ocr2
  thirdline
  lcd "kp=" ; fusing(kp , "#.###") ; "ki=" ; fusing(ki , "#.###")
  fourthline
  lcd "kd= " ; fusing(kd , "#.###")

Loop

'*******************************************************************************
'*****  Podprogramy
'*******************************************************************************

'-------------------------------------------------------------------------------
Zegar:
enable interrupts
enable int0
Timer0 = 6                                                  ' 2ms
pv = n
n = 0

       If Auto_mode = 1 Then
      ' -------- Regulating modus
      Error = Sp - Pv
      Sum_error = Sum_error + Error
      Iterm = Ki * Sum_error                                ' Integrated CV part

      ' -------- First time startup
      If First_execution < 2 Then
         If First_execution = 0 Then
            Sum_error = Manual_value / Ki
            First_execution = 1
            Initial_error = Error
         End If
         Pterm = 0
         Dterm = 0
         If Initial_error > 0 And Error < 0 Then
            First_execution = 2
            Last_pv = Pv
         End If
         If Initial_error < 0 And Error > 0 Then
            First_execution = 2
            Last_pv = Pv
         End If
         Last_sp = Sp

      ' -------- Normal calculation loop
      Else
         D_pv = Last_pv - Pv
         Last_pv = Pv
         Dterm = Kd * D_pv                                  ' Derivated CV part
         If Sp = Last_sp Then
            ' -------- Normal loop when setpoint not changed
            Pterm = Kp * Error                              ' Proportional CV part
            ' -------- Loop when setpoint changed
            Else
            Pterm = 0
            Dterm = 0
            If Sp > Last_sp And Pv > Sp Then
               Last_sp = Sp
               Last_pv = Pv
            End If
            If Sp < Last_sp And Pv < Sp Then
               Last_sp = Sp
               Last_pv = Pv
            End If
         End If                                             ' Enf of SP change seperation                                   '
      End If                                                ' Enf of first time running seperation                                  '

      Cv = Pterm + Iterm                                    ' Summing of the tree
      Cv = Cv + Dterm                                       ' calculated terms

   ' -------- Forced modus
   Else                                                     ' When running in non regulationg modus
      Cv = Manual_value                                     ' Set output to predefined value
      First_execution = 0                                   ' restart bumpless
   End If
'-------------------
ocr2 = cv
Return
'-------------------------------------------------------------------------------
'Odczyt enkodera
Licz:
  Incr N
return
'-----------

' -----[ Start of program ]-----------------------------------------------------
' -----[ Start of program ]-----------------------------------------------------
' -----[ Start of program ]-----------------------------------------------------



Cyclic:
' -----[ Start of endless running program ]-------------------------------------
'   Waitms 50                                                ' PID must run deterministic
'                                                  ' time slices
'   Gosub Regulator                                          ' Call the PID allgorithm
'   Gosub Object                                             ' Call the simulated outer loop
'   Goto Cyclic

   ' -----[ End of endless running program ]------------------------------------
   ' -----[ End of endless running program ]------------------------------------
   ' -----[ End of endless running program ]------------------------------------


   ' ---------------------------------------------------------------------------
   ' -----------------------------[ Subroutines ]-------------------------------
   ' ---------------------------------------------------------------------------
'Object:
   ' -----[ Start of simulated regulation loop ]--------------------------------
'    Pv = Pv + Cv                                            ' linear function used

'    If Pv = Sp Then                                         ' When PV=SP then make a
'       A = Rnd(100)                                         ' random SP jump
'       Sp = 1 * A
'    End If
'Return